module ftp_end_to_end
open ftp_shared

// simple file transfer system with end to end check that allows unreliable network

sig Sender_E2E extends Sender {} {
	this in OK iff network.inpackets = blocks + hash
	}

sig Receiver_E2E extends Receiver {receivedHash: Hash} {
	this in OK iff network.outpackets = blocks + receivedHash
	}

sig FileTransferReq extends FTP_Requirement {} {
	this in OK iff (from.file.blocks = to.file.blocks or to.client.receivedHash != to.client.hash)
	}	

fact {
	FileTransferReq.trustedBase = Sender + Receiver + FileSystem
	}
